default:
  image: docker:24.0.5
  services:
    - docker:24.0.5-dind
stages:
  - image_build
  - test
  - update_k8s_manifest

variables:
  CD_GIT_REPOSITORY: git@gitlab.com:ashok.kammala/argocd-demo.git
  CD_CHART_REPO: argocd-demo
  CD_MANIFEST_FILE: values.yaml
  IMAGE_NAME: registry.gitlab.com/ashok.kammala/nginx:$CI_COMMIT_SHORT_SHA


build_image:
  stage: image_build
  before_script:
    - echo "Logging in to DockerHub"
    - docker login registry.gitlab.com -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASS
  script:
    - docker build -t $IMAGE_NAME .
    - docker push $IMAGE_NAME     

trivy:
  stage: test
  image: docker:stable-git
  before_script:
    - docker pull $IMAGE_NAME
    - wget https://github.com/aquasecurity/trivy/releases/download/v0.1.6/trivy_0.1.6_Linux-64bit.tar.gz
    - tar zxvf trivy_0.1.6_Linux-64bit.tar.gz
  variables:
    DOCKER_DRIVER: overlay2
  allow_failure: true
  services:
    - docker:stable-dind
  script:
    - ./trivy --severity HIGH --no-progress --auto-refresh $IMAGE_NAME
    - ./trivy --severity CRITICAL --no-progress --auto-refresh $IMAGE_NAME


update_manifest:
  stage: update_k8s_manifest
  script:
    - apk add --no-cache git
    - mkdir -p /root/.ssh
    - echo "$SSH_PRIVATE_KEY" > /root/.ssh/id_rsa
    - ssh-keyscan -H gitlab.com > /root/.ssh/known_hosts
    - chmod 600 /root/.ssh/id_rsa
    - git config --global user.name ashok.kammala
    - git config --global user.email ashok.kammala@gmail.com
    - git clone --single-branch --branch main $CD_GIT_REPOSITORY
    - cd $CD_CHART_REPO
    - docker run --rm -v ${PWD}:/workdir mikefarah/yq:3.2.1 yq write --inplace --verbose $CD_MANIFEST_FILE image.tag $CI_COMMIT_SHORT_SHA
    - git add values.yaml
    - cat values.yaml
    - git commit -am "update image tag" && git push origin main

